#include "wndmain.h"

#include <QApplication>
#include <QDir>
#include <QDesktopServices>


cWndMain::cWndMain (QWidget *Parent) : QMainWindow (Parent)
{
#if defined (USE_WEBKIT)
	setWindowTitle ("Test with WebKit and Qt " + QString (qVersion ()));

	WebView = new QWebView;

	connect (WebView, SIGNAL (linkClicked (const QUrl&)), this, SLOT (LinkClicked (const QUrl&)));

	QWebPage *Page = WebView->page ();

	if (Page != NULL)
		Page->setLinkDelegationPolicy (QWebPage::DelegateExternalLinks);
#elif defined (USE_WEBENGINE)
	setWindowTitle ("Test with WebEngine and Qt " + QString (qVersion ()));

	WebView = new QWebEngineView;

	cWebEnginePage *Page = new cWebEnginePage;
	WebView->setPage (Page);
#endif

	setCentralWidget (WebView);
	WebView->show ();

	DisplayHtmlPage ();
}


cWndMain::~cWndMain ()
{}


void cWndMain::LinkClicked (const QUrl &Url)
{
	QDesktopServices::openUrl (Url);
}


void cWndMain::DisplayHtmlPage ()
{
	QString HtmlPage = QApplication::applicationDirPath ();

#if defined (Q_OS_MACX)
	HtmlPage += "/../../../../";
#else
	HtmlPage += "/../../";
#endif

	HtmlPage += "/example/accueil.html";

	HtmlPage = QDir::cleanPath ("/Users/andy/tasks/TestWeb/example/accueil.html");
	HtmlPage = QDir::toNativeSeparators (HtmlPage);

	QUrl Url =QUrl::fromLocalFile (HtmlPage);

	WebView->setUrl (Url);
}







#if defined (USE_WEBENGINE)

cWebEnginePage::cWebEnginePage (QObject *Parent) : QWebEnginePage (Parent)
{
	IsLoading = false;

//	connect (this, SIGNAL (loadStarted (void)), this, SLOT (LoadStarted (void)));
//	connect (this, SIGNAL (loadFinished (bool)), this, SLOT (LoadFinished (bool)));
}


cWebEnginePage::cWebEnginePage (QWebEngineProfile *Profile, QObject *Parent) : QWebEnginePage (Profile, Parent)
{
	IsLoading = false;
}


cWebEnginePage::~cWebEnginePage ()
{}


bool cWebEnginePage::acceptNavigationRequest (const QUrl &Url, NavigationType Type, bool IsMainFrame)
{
	if ((IsLoading == false) && (Type == QWebEnginePage::NavigationTypeLinkClicked))
	{
		QDesktopServices::openUrl (Url);
		return true;
	}
	else
		return QWebEnginePage::acceptNavigationRequest (Url, Type, IsMainFrame);
}


void cWebEnginePage::LoadStarted ()
{
	IsLoading = true;
}


void cWebEnginePage::LoadFinished (bool Ok)
{
	if (Ok == true)
		IsLoading = false;
}

#endif // #if defined (USE_WEBENGINE)




