#ifndef WNDMAIN_H
#define WNDMAIN_H


#include <QMainWindow>


#if defined (USE_WEBKIT)
	#include <QWebView>
#elif defined (USE_WEBENGINE)
	#include <QWebEngineView>
#endif

class cWndMain : public QMainWindow
{
	Q_OBJECT

	public :
		cWndMain (QWidget *Parent = NULL);
		~cWndMain ();

	private slots :
		void LinkClicked (const QUrl &Url);

	private :
#if defined (USE_WEBKIT)
		QWebView *WebView;
#elif defined (USE_WEBENGINE)
		QWebEngineView *WebView;
#endif

		void DisplayHtmlPage ();
};




#if defined (USE_WEBENGINE)

class cWebEnginePage : public QWebEnginePage
{
	Q_OBJECT

	public :
		cWebEnginePage (QObject *Parent = NULL);
		cWebEnginePage (QWebEngineProfile *Profile, QObject *Parent = NULL);
		~cWebEnginePage ();

	protected :
		virtual bool acceptNavigationRequest (const QUrl &Url, NavigationType Type, bool IsMainFrame);

	private slots :
		void LoadStarted ();
		void LoadFinished (bool Ok);


	private :
		bool IsLoading;

};

#endif // #if defined (USE_WEBENGINE)



#endif // WNDMAIN_H
