$(document).ready(function(){
    $('.popup-wrapper .close').click(function(){
        $(this).parents('.popup-wrapper').hide();
    });

    $('.survey input[type="radio"]').click(function(){
        var $this = $(this);
        var $label = $this.parent('.lblradio');
        var $questionContent = $label.parents('.question-content');
        $questionContent.find('.lblradio').removeClass('checked');
        $label.toggleClass('checked');
   });

});

function show_feedback_form(elem){
    var $feedbackCcontainer = $(elem).parents('.feedback-container');
    $feedbackCcontainer.find('.survey').addClass('opened');
    $feedbackCcontainer.find('.header-intro .btn-container').hide();


    var $questionSlider = $feedbackCcontainer.find('.question-slider').owlCarousel({
        margin:0,
        autoWidth:false,
        items:1,
        nav: false,
        dots: false,
        slideBy: 'page',
        mouseDrag: false,
        pullDrag: false,
        touchDrag: false
    });

    var $surveyNav = $feedbackCcontainer.find('.survey-nav');
    $surveyNav.find('.prev-trigger').click(function(){
        $questionSlider.trigger('prev.owl.carousel');
    });

    $surveyNav.find('.next-trigger').click(function(){
        $questionSlider.trigger('next.owl.carousel');
    });

    $questionSlider.on('changed.owl.carousel', function(event){
        var current_item_index = parseInt(event.item.index+1,10);
        $surveyNav.removeClass('current-item-1 current-item-2 current-item-3 current-item-4 ').addClass('current-item-'+current_item_index);

        $surveyNav.find('.pagination-item').removeClass('current').eq(current_item_index-1).addClass('current');
    });

    var $survey = $('.survey');
    $survey.find('form').submit(function(event){

        var has_errors = false;
        var first_error_at = 4;
        var question_num;
        $survey.find('.question-label').removeClass('error');
        $survey.find('input[type="radio"]').each(function(){
            var $radio = $(this);
            var one_checked = atLeastOneRadioChecked($radio.attr('name'));

            if(one_checked == false){
                $radio.parent('.lblradio').prev('.question-label').addClass('error');

                question_num = $radio.parents('.item').find('.question-num').html();
                if(question_num < first_error_at){
                    first_error_at = question_num;
                }
            }


            if(has_errors == false && one_checked == false){
                has_errors = true;
            }

        })

        if(has_errors == true){
            $questionSlider.trigger('to.owl.carousel',[first_error_at-1]);
        }else{
            complete_feedback();
        }

        return false;

    });
}

function postponed_feedback(elem){
    /*var feedback_id = $(elem).parents('.feedback-container').data('feedbackId');
     var data = {
     "feedback_id" : feedback_id
     };*/

    var promise = $.post('handlers/feedback.php?action=postponed');
    promise.then(function(){
        close_feedback_form(elem);
    })
}

function close_feedback_form(elem){
    $(elem).parents('.popup-wrapper').hide();
}

function complete_feedback(elem){
    var $survey = $('.survey');
    var data = $survey.find('form').serializeArray();

    var promise = $.post('handlers/feedback.php?action=complete',data);
    promise.then(function(response){
        if(response.success == 1){
            $survey.hide();
            var $feedbackContainer = $('.feedback-container');
            $feedbackContainer.find('.header-intro').hide();
            $feedbackContainer.find('.header-success').show();
        }else{
            alert(response.msg);
        }
    })
}

function atLeastOneRadioChecked(name){
    return ($('input[type="radio"][name="'+name+'"]:checked').size() > 0);
}